// JavaScript Variables

var myString  = "This is a string";

var myBoolean = false;

var myNumber  = 5;

var myObject  = {
  myKey: "myValue",
  myOtherKey: {
    myOtherOtherKey: "myOtherOtherValue"
  }
};

var myArray   = [2, 3, 4, 5];

// String concatenation
var numBlue  = 2,
    numGreen = 5;

var colorString = "There are " + numBlue + numGreen + " objects.";
// Results in: "There are a total of 25 objects."

// ...

var colorStringWorking = "There are " + (numBlue + numGreen) + " objects.";
// Results in: "There are a total of 7 objects."


var a;
console.log("The value of a is " + a); // logs "The value of a is undefined"
console.log("The value of b is " + b); // throws ReferenceError exception

//Let's create a `mustang` object

var mustang = {};

//For example, here are some methods

// ```javascript
// > mustang.toString();
//   "[Object object]"
// 
// > mustang.constructor()
//   Object {}
// 
// > mustang.constructor
//   function Object() { [native code] }


// Dot notation

var mustang = {};

mustang.make = "Ford";
mustang.model = "Mustang";
mustang.year = 2015;

// Square brackets

var mustang = {};

mustang["make"] = "Ford";
mustang["model"] = "Mustang";
mustang["year"] = 2015;

// Literal Notation

var mustang = {
  make: "Ford",
  model: "Mustang",
  year: 2015
};

// You can also do a combination, if you need to.

// Define base properties
var mustang = {
  make: "Ford",
  model: "Mustang",
  year: 2015
};


// Define an additional property
mustang.color = "Red";

//You can also add methods on objects:

// Define base properties
var mustang = {
  make: "Ford",
  model: "Mustang",
  year: 2015,
  
  description: function() {
    return this.year + " " + this.make + " " + this.model;
  }
  
};

// This won't scale well…

var mustang = {
  make: "Ford",
  model: "Mustang",
  year: 2015,
  
  description: function() {
    return this.year + " " + this.make + " " + this.model;
  }
};

var camaro = {
  make: "Chevrolet",
  model: "Camaro",
  year: 2015,
  
  description: function() {
    return this.year + " " + this.make + " " + this.model;
  }
};


// Instead, create a `car` `Object` as the base

var car = {

  description: function() {
    return this.year + " " + this.make + " " + this.model;
  }

};


// Then use the `Object.create()` method 

var mustang = Object.create(car);
mustang.make = "Ford";
mustang.model = "Mustang";
mustang.year = 2015;

var camaro = Object.create(car);
camaro.make = "Chevrolet";
camaro.model = "Camaro";
camaro.year = 2015;

// Why not just pass in the properties as values?

// Doesn't work
var mustang = Object.create(car, {
  make: "Ford",
  model: "Mustang",
  year: 2015
});


// Works
var mustang = Object.create(car, {
  make: {
    value: "Ford"
  },
  model: {
    value: "Mustang"
  },
  year: {
    value: 2015
  }
});


// A programming problem
var haystack    = [4, 52, 29, 100, -50, 10];
var needle      = -46;
var hasSumOfTwo = false;

// A solution
var map = {};
for(var i=0; i<haystack.length; i++) {
  var num = haystack[i],
      key = needle-num;
      
  if(map[key]) {
    hasSumOfTwo = true;
  }
  map[num] = true;
}