
// From: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Functions_and_function_scope

/* Declare the function 'myFunc' */
 function myFunc(theObject)
 {
   theObject.brand = "Toyota";
 }
 
 /*
  * Declare variable 'mycar';
  * create and initialize a new Object;
  * assign reference to it to 'mycar'
  */
 var mycar = {
   brand: "Honda",
   model: "Accord",
   year: 1998
 };

 /* Shows 'Honda' */
 window.alert(mycar.brand);

 /* Pass object reference to the function */
 myFunc(mycar);

 /*
  * Shows 'Toyota' as the value of the 'brand' property
  * of the object, as changed to by the function.
  */
 window.alert(mycar.brand);
 
 
////////////////////


// Instead of having functions at the global level...
function add(x, y) {
   return x + y;
}

function subtract(x, y) {
   return x - y;
}

var mathFunctions = {
  add: function(x, y) {
     return x + y;
  },
  subtract: function(x, y) {
     return x - y;
  }
};


/////////////////////

// Closures:

function addSquares(a,b) {
   function square(x) {
      return x * x;
   }
   return square(a) + square(b);
}
a = addSquares(2,3); // returns 13
b = addSquares(3,4); // returns 25
c = addSquares(4,5); // returns 41




function outside(x) {
   function inside(y) {
      return x + y;
   }
   return inside;
}
fn_inside = outside(3); // Think of it like: give me a function that adds 3 to whatever you give it
result = fn_inside(5); // returns 8

result1 = outside(3)(5); // returns 8


function A(x) {
   function B(y) {
      function C(z) {
         alert(x + y + z);
      }
      C(3);
   }
   B(2);
}
A(1); // alerts 6 (1 + 2 + 3)


// Ember String formatter, mostly

String.prototype.fmt = function() {
  var string = this.toString();
  if(arguments.length) {
    var formats = arguments,
        index   = 0;

    return string.replace(/%@([0-9]+)?/g, function (match, argumentIndex) {
      argumentIndex = (argumentIndex) ? parseInt(argumentIndex, 10) - 1 : index++;
      match = formats[argumentIndex];

      return ((match === null) ? '(null)' : (match === undefined) ? '' : match).toString();
    });
  }
  return string;
};



